#include "..\h\aefiller.h"


AEFILLER::AEFILLER(int X, int Y) 
{ 
	flatscreen=new unsigned char[X*Y*4];
	Xres=X;
	Yres=Y; 
	Xmul=(float)Xres/2-1.0f; Xadd=Xmul+0.5f;
	Ymul=(float)Yres/2-1.0f; Yadd=Ymul+0.5f;
}


void AEFILLER::Triangle(float fs_x1, float fs_y1, float fs_x2, float fs_y2, float fs_x3, float fs_y3, long szin)
{
#define FBITS 16
#define FAND (-65536) //-(1 SHL FBITS)
#define FONE (65536)//(1 SHL FBITS)
#define FFRAC (65536)//FONE

float fl_x1=fs_x1*Xmul+Xadd;
float fl_x2=fs_x2*Xmul+Xadd;
float fl_x3=fs_x3*Xmul+Xadd;
float fl_y1=fs_y1*Ymul+Yadd;
float fl_y2=fs_y2*Ymul+Yadd;
float fl_y3=fs_y3*Ymul+Yadd;
long szinr=szin;
long soradd=Xres;
float frac=65536.0;
long x1   =0;
long y1   =0;
long x2   =0;
long y2   =0;
long x3   =0;
long y3   =0;

long y1i  =0;
long y2i  =0;
long y3i  =0;

long fl_deltax12 =0;
long fl_deltay12 =0;
long fl_deltax13 =0;
long fl_deltay13 =0;
long fl_deltax23 =0;
long fl_deltay23 =0;

long deltay12 =0;
long deltay13 =0;
long deltay23 =0;

long fl_delta12  =0;
long fl_delta13  =0;
long fl_delta23  =0;
long delta12  =0;
long delta13  =0;
long delta23  =0;

long deltas   =0;
long deltae   =0;
long xs       =0;
long xe       =0;
long scrptr   =0;

long ys       =0;
long ye       =0;
long dy       =0;
long height   =0;

unsigned short sys =0;
unsigned char *barmi=flatscreen;

	_asm {
//        push    ebp
//       mov     ebp,esp
        pushad

		fnstcw sys
		mov ax,sys
		mov x1,eax
		and x1,1111110011111111b
		fldcw word ptr x1

// sort the vertices from top to bottom
        //include .\inc\sort.inc
         mov eax, fl_y1
         mov ebx, fl_y2
         cmp eax, ebx
         jna y1_na_y2
         mov fl_y2,eax
         mov fl_y1,ebx
//         xchg2  fl_x1, fl_x2
mov eax,fl_x1
mov ebx,fl_x2
mov fl_x2,eax
mov fl_x1,ebx

y1_na_y2:            mov eax, fl_y1
         mov ebx, fl_y3
         cmp eax, ebx
         jna y1_na_y3
         mov fl_y3,eax
         mov fl_y1,ebx
//         xchg2  fl_x1, fl_x3
mov eax,fl_x1
mov ebx,fl_x3
mov fl_x3,eax
mov fl_x1,ebx

y1_na_y3:            mov eax, fl_y2
         mov ebx, fl_y3
         cmp eax, ebx
         jna y2_na_y3
         mov fl_y3,eax
         mov fl_y2,ebx
//         xchg2  fl_x2, fl_x3
mov eax,fl_x2
mov ebx,fl_x3
mov fl_x3,eax
mov fl_x2,ebx
y2_na_y3:
		
// convert floats to 16.16 fixed point
		fld		fl_x1  //x1
		fmul    frac   //x1*1
		fld     fl_y1  //y1 x1*1
		fmul    frac   //y1*1 x1*1
		fld     fl_x2  //x2 y1*1 x1*1
		fmul    frac   //x2*1 y1*1 x1*1
		fld     fl_y2  //y2 x2*1 y1*1 x1*1
		fmul    frac   //y2*1 x2*1 y1*1 x1*1
		fld     fl_x3  //x3 y2*1 x2*1 y1*1 x1*1
		fmul    frac   //x3*1 y2*1 x2*1 y1*1 x1*1
		fld     fl_y3  //y3 x3*1 y2*1 x2*1 y1*1 x1*1
		fmul    frac   //y3*1 x3*1 y2*1 x2*1 y1*1 x1*1
		fxch    st(5)  //x1*1 x3*1 y2*1 x2*1 y1*1 y3*1
		fistp   x1     //x3*1 y2*1 x2*1 y1*1 y3*1
		fxch    st(3)  //y1*1 y2*1 x2*1 x3*1 y3*1
		fistp   y1     //y2*1 x2*1 x3*1 y3*1
			mov     eax,y1
		fxch    st(1)  //x2*1 y2*1 x3*1 y3*1
		fistp   x2     //y2*1 x3*1 y3*1
		fxch    st(1)  //x3*1 y2*1 y3*1
		fistp   x3     //y2*1 y3*1
		fistp   y2     //y3*1
			mov     ebx,y2
		fistp   y3

        mov     ecx,y3
        and     eax,FAND
        and     ebx,FAND
        and     ecx,FAND
        mov     y1i,eax
        mov     y2i,ebx
        mov     y3i,ecx

        cmp     eax,ecx
        je      polyfill_vege

// calculate the differnce in coords
//        include .\inc\deltafxy.inc
        fld     fl_y3
        fld     fl_y2
        fld     fl_y3           //y3 y2 y3

        fsub    fl_y1           //y3-y1 y2 y3
        fxch                    //y2 y3-y1 y3
        fsub    fl_y1           //y2-y1 y3-y1 y3
        fxch    st(2)           //y3 y3-y1 y2-y1
        fsub    fl_y2           //y3-y2 y3-y1 y2-y1
        fxch                    //y3-y1 y3-y2 y2-y1
        fstp    fl_deltay13     //y3-y2 y2-y1
        fxch                    //y2-y1 y3-y2
        fstp    fl_deltay12     //y3-y2
        fstp    fl_deltay23

        fld     fl_x3
        fld     fl_x2
        fld     fl_x3           //x3 x2 x3

        fsub    fl_x1           //x3-x1 x2 x3
        fxch                    //x2 x3-x1 x3
        fsub    fl_x1           //x2-x1 x3-x1 x3
        fxch    st(2)           //x3 x3-x1 x2-x1
        fsub    fl_x2           //x3-x2 x3-x1 x2-x1
        fxch                    //x3-x1 x3-x2 x2-x1
        fstp    fl_deltax13     //x3-x2 x2-x1
        fxch                    //x2-x1 x3-x2
        fstp    fl_deltax12     //y3-y2
        fstp    fl_deltax23

        fld     fl_deltax13
        fdiv    fl_deltay13
//        include .\inc\deltaxy.inc
		mov eax,y1i
		mov ebx,y2i
		mov ecx,y3i
		mov deltay12,ebx
		sub deltay12,eax
		mov deltay23,ecx
		sub deltay23,ebx
		mov deltay13,ecx
		sub deltay13,eax

        fmul    frac
        fistp   delta13

        cmp     deltay12,0
        je      deltay12_not_ok

        fld     fl_deltax12
        fdiv    fl_deltay12
        fst     fl_delta12
        fmul    frac
        fistp   delta12
        jmp     deltay12_ok

deltay12_not_ok:
        mov     eax,x1
        cmp     eax,x2
        jl      bal
        jmp     jobb

// determine which side the longer edge is on
deltay12_ok:
        mov     eax,delta13
        cmp     eax,delta12
        je      polyfill_vege
        jg      jobb

//hosszabb el a bal oldalon van
bal:
//        include    .\inc\bal.inc

        mov     eax,delta13
        mov     deltas,eax

        mov     eax,y1
        mov     dy,FONE
        sub     eax,y1i
        sub     dy,eax         //dy=1-(y1-y1i)

        mov     eax,dy
        imul    deltas
        shrd    eax,edx,FBITS

        mov     xs,eax
        mov     ebx,x1
        add     xs,ebx         //xs=x1+dy*deltas

//
        mov     eax,y2i
        mov     ebx,y1i
        cmp     eax,ebx
        jbe     bal_also
        shr     eax,FBITS
        shr     ebx,FBITS
        mov     ye,eax
        mov     ys,ebx

        mov     eax,dy
        imul    delta12
        shrd    eax,edx,FBITS

        mov     xe,eax
        mov     ebx,x1
        add     xe,ebx         //xe=x1+dy*deltae

        mov     eax,delta12
        mov     deltae,eax     //deltae=dxdy12


        call    line


//
bal_also:
        mov     eax,y3i
        mov     ebx,y2i
        cmp     eax,ebx
        jbe     polyfill_vege

        fld     fl_deltax23
        fdiv    fl_deltay23

        shr     eax,FBITS
        shr     ebx,FBITS
        mov     ye,eax
        mov     ys,ebx

        mov     eax,y2
        mov     dy,FONE
        sub     eax,y2i
        sub     dy,eax         //dy=1-(y2-y2i)

        fst     fl_delta23
        fmul    frac
        fistp   delta23

        mov     eax,dy
        imul    delta23
        shrd    eax,edx,FBITS

        mov     xe,eax
        mov     ebx,x2
        add     xe,ebx         //xe=x2+dy*delta23

        mov     eax,delta23
        mov     deltae,eax

        call    line
        jmp     polyfill_vege

//hoszabb el a jobb oldalon van
jobb:  // include    .\inc\jobb.inc

        mov     eax,y1
        mov     dy,FONE
        sub     eax,y1i
        sub     dy,eax         //dy=1-(y1-y1i)

        mov     eax,delta13
        mov     deltae,eax

        mov     eax,dy
        imul    deltae
        shrd    eax,edx,FBITS

        mov     xe,eax
        mov     ebx,x1
        add     xe,ebx         //xe=x1+dy*deltae

//
        mov     eax,y2i
        mov     ebx,y1i
        cmp     eax,ebx
        jle     jobb_also
        shr     eax,FBITS
        shr     ebx,FBITS
        mov     ye,eax
        mov     ys,ebx

        mov     eax,delta12
        mov     deltas,eax

        mov     eax,dy
        imul    deltas
        shrd    eax,edx,FBITS

        mov     xs,eax
        mov     ebx,x1
        add     xs,ebx         //xs=x1+dy*deltas

        call    line

//
jobb_also:
        mov     eax,y3i
        mov     ebx,y2i
        cmp     eax,ebx
        jle     polyfill_vege

        fld     fl_deltax23
        fdiv    fl_deltay23

        shr     eax,FBITS
        shr     ebx,FBITS
        mov     ye,eax
        mov     ys,ebx

        mov     eax,y2
        mov     dy,FONE
        sub     eax,y2i
        sub     dy,eax         //dy=1-(y2-y2i)

        fst     fl_delta23
        fmul    frac
        fistp   delta23

        mov     eax,delta23
        mov     deltas,eax

        mov     eax,dy
        imul    deltas
        shrd    eax,edx,FBITS

        mov     xs,eax
        mov     ebx,x2
        add     xs,ebx         //xs=x2+dy*delta23

        call    line
		jmp		polyfill_vege
line:
		mov  ebx,ye
		mov  eax,ys
		sub  ebx,eax //;ys
		mov  height,ebx
		mov	edi,soradd
		mul	edi
		mov	edi,eax
		add  edi,barmi
		mov  scrptr,edi

		ujsor:      mov  ecx,xe
		mov  ebx,xs
		shr  ecx,FBITS
		mov  edi,scrptr
		shr  ebx,FBITS
		mov  eax,szinr
		sub  ecx,ebx
		jbe   no_line

		add  edi,ebx
		shr  ecx,1
		jnc  v1
		stosb
		v1:             or   ecx,ecx
		je   no_line
		shr  ecx,1
		jnc  v2
		stosw
		v2:             or   ecx,ecx
		je   no_line
		rep  stosd

		no_line:
		mov  eax,deltas
		mov  ebx,deltae
		add  xs,eax
		add  xe,ebx

		mov	eax,soradd
		add  scrptr,eax
		dec  height
		jne  ujsor

		ret

polyfill_vege:
fldcw sys
        popad
//        pop ebp
	}
}
